
#include "defextern.h"
#include "main.h"
#include "asciimovie.h"
#include "asciiframe.h"
#include "editproc.h"
#include "file.h"
#include "color.h"

ULONG nummax=0;
ULONG maxlength=0;
BOOL soundflag;
char endmark[]="[end]";
char buffernow[buffermax+1];
char buffercopy[buffermax+1];
//char lineend[]="\x0d\x0a";

struct koma
{
	BOOL colorflag;
	BOOL soundflag;
	BOOL sameflag;
	int penR,penG,penB,bR,bG,bB;
	ULONG samenum;
	char color[50];
	char sound[MAX_PATH];
	char aadata[buffermax+1];

	void setcolor(int R,int G,int B,int r,int g,int b)
	{
		penR=R;penG=G;penB=B;bR=r;bG=g;bB=b;
		wsprintf(color,"%d %d %d %d %d %d",R,G,B,r,g,b);
		colorflag=TRUE;
	};
	void setsound(char *name)
	{
		strncpy(sound,name,MAX_PATH);
		soundflag=TRUE;
	};
	void setsamenum(ULONG num)
	{
		samenum=num;
		sameflag=TRUE;
	};
	void reset(){noheader();};
	void setaadata(char *data){strncpy(aadata,data,buffermax+1);};
	void noheader(){colorflag=FALSE;soundflag=FALSE;sameflag=FALSE;};
	void getalldata(char *buff);
};

void koma::getalldata(char *buff)
{
	char *p=buff;
	if(colorflag || soundflag ||sameflag)
	{
		*p=headerstart;
		p ++;
		strcpy(p,lineend);
		p +=strlen(lineend);
		if(sameflag)
		{
			wsprintf(p,"same %d",samenum,lineend);
			p +=(strlen(sound)+strlen(lineend)+5);
		}
		if(colorflag)
		{
			wsprintf(p,"color%s%s%s",lineend,color,lineend);
			p +=(strlen(color)+strlen(lineend)*2+5);
		}
		if(soundflag)
		{
			wsprintf(p,"sound%s%s%s",lineend,sound,lineend);
			p +=(strlen(sound)+strlen(lineend)*2+5);
		}
		*p=headerend;
		p ++;
		strcpy(p,lineend);
		p +=strlen(lineend);
	}
	strcpy(p,aadata);
}


koma komanow;


char soundfile[buffermax+1];

char *nextline(char *p)
{
	p=strchr(p,lineend[0]);
	if(p!=NULL) p++;
	if(p!=NULL) p++;
	return p;
}

void Sound()
{
	if(soundflag) PlaySound(soundfile,NULL,SND_ASYNC);
}

void SetSoundName(char *name)
{
	char *buffer=buffernow;
	char *p=buffercopy;
	komanow.setsound(name);
	komanow.getalldata(buffer);
	SetWindowText(hwndEdit,buffer);
}

// TEh`FbNATEht@CɃRs[isj

BOOL checksame(char *name,char *buffer=showbuffer)
{
	BOOL ans=FALSE;
	ULONG num;
	char *p;
	if(strncmp(buffer,"same",4)==0) 
	{
		ans =TRUE;
		p +=4;
		if(p!=NULL)
		{
			sscanf(p,"%d",&num);
			komanow.setsamenum(num);
			loadframe(name,num);
			ans=TRUE;
		}
	}
	return ans;
}

// TEh`FbNATEht@CɃRs[isj

BOOL checksound(char *buffer=showbuffer)
{
	BOOL ans=FALSE;
	char *p;
	if(strncmp(buffer,"sound",5)==0) 
	{
		ans =TRUE;
		p=strchr(buffer,lineend[0])+2;
		strcpy(soundfile,p);
		komanow.setsound(p);
		p=strchr(soundfile,lineend[0]);
		if(p!=NULL) *p='\0';
	}
	return ans;
}

BOOL checkcolor(char *buffer)
{
	int R,G,B,r,g,b;
	BOOL ans=FALSE;
	//buffer[strlen(buffer)]='\0';
	char *p=buffer;
	if(strncmp(buffer,"color",5)==0) 
	{
		p=strchr(buffer,lineend[0])+2;
		if(p!=NULL)
		{
			sscanf(p,"%d %d %d %d %d %d",&R,&G,&B,&r,&g,&b);
			setcolor(pencolor,R,G,B);
			setcolor(bcolor,r,g,b);
			komanow.setcolor(R,G,B,r,g,b);
			changecolor();
			ans=TRUE;
		}
	}
	return ans;
}

void setmode(int m)
{
	mode =m;
}

ULONG getframenum()
{
	return nownum;
}

void framenumreset()
{
	nownum=0;
}

void framenumplus(long n)
{
	n=n+nownum;
	nownum =max(0,n);
	nummax =max(nownum,nummax);
}


//---------------------------------------
// ݂̃R}ʒũR}폜i߂j

void deleteframe(char *name)
{
	char *filefrom=buffernow;
	char *fileto=buffercopy;
	
	nummax=searchnummax(name);
	ULONG num=0;
	wsprintf(filefrom,"%s%04d.txt",name,nownum);
	remove(filefrom);
	for(num=nownum;num<nummax;num++)
	{
		wsprintf(filefrom,"%s%04d.txt",name,num+1);
		wsprintf(fileto,"%s%04d.txt",name,num);
		rename(filefrom,fileto);
	}
}

//---------------------------------------
// ݂̃R}ʒuɋ󔒃R}}

void insertframe(char *name)
{
	char *filefrom=buffernow;
	char *fileto=buffercopy;
	/*
	GetCurrentDirectory(MAX_PATH,filefrom);
	*/
	
	nummax=searchnummax(name);
	ULONG num=0;
	for(num=nummax;num>=nownum;num--)
	{
		wsprintf(filefrom,"%s%04d.txt",name,num);
		wsprintf(fileto,"%s%04d.txt",name,num+1);
		rename(filefrom,fileto);
	}
}

void saveframe(char *name)
{
	char *buffer=buffernow;
	wsprintf(buffer,"%s%04d.txt",name,nownum);
	ofstream ou(buffer,ios::binary);
	GetWindowText(hwndEdit,buffer,buffermax);
	ou.write(buffer,strlen(buffer));
	//if(nownum==0) loadcolor(name);
}

void savecolor(char *name)
{
	int num=nownum;
	char *buffer=buffernow;
	wsprintf(buffer,"%s%04d.txt",name,num);
	komanow.setcolor(pencolor.R,pencolor.G,pencolor.B,bcolor.R,bcolor.G,bcolor.B);
	ofstream ou(buffer,ios::binary);
	komanow.getalldata(buffer);
	ou.write(buffer,strlen(buffer));
	SetWindowText(hwndEdit,buffer);
}


ULONG searchmax(char *name , char *buffer)
{
	int num=0;
	ULONG max=0;
	while(num<nummax)
	{
		wsprintf(buffer,"%s%04d.txt",name,num);
		ifstream in(buffer,ios::binary | ios::nocreate);
		if(in)
		{
			in.read(buffer,buffermax);
			max=max(max,in.gcount());
		}
		num++;
	}
	return max;
}

ULONG searchnummax(char *name)
{
	ULONG num=10000;
	return num;
}



void saveallframe(char *name)
{
	ULONG num=0;
	char *buffer=buffernow;
	wsprintf(buffer,"%s.txt",name);
	ofstream ou(buffer,ios::binary);
	nummax=searchnummax(name);
	//maxlength =searchmax(name,buffer);
	maxlength=buffermax;
	memset(buffer,0,buffermax);
	//wsprintf(buffer,"%d",maxlength);
	//ou.write(buffer,strlen(buffer));
	//ou.write(lineend,2);
	while(num<nummax)
	{
		wsprintf(buffer,"%s%04d.txt",name,num);
		ifstream in(buffer,ios::binary | ios::nocreate);
		memset(buffer,0,buffermax);
		if(in)
		{
			wsprintf(buffer,"%04d",num);
			ou.write(buffer,strlen(buffer));
			ou.write(lineend,2);
			memset(buffer,0,buffermax);
			in.read(buffer,maxlength);
			ou.write(buffer,strlen(buffer));
			ou.write(lineend,2);
			ou.write(endmark,strlen(endmark));
			ou.write(lineend,2);
		}
		num++;
	}
}


void loadcolor(char *name)
{
	char *buffer=buffernow;
	int num=0;
	ifstream in;
	memset(buffer,0,buffermax);
	if(mode==MODE_MAKING)
	{
		wsprintf(buffer,"%s%04d.txt",name,num);
		in.open(buffer,ios::binary | ios::nocreate);
		if(!in) return;
	}
	if(mode==MODE_ALL)
	{
		int num=0;
		char dummy[10];
		wsprintf(buffer,"%s.txt",name);
		in.open(buffer,ios::binary | ios::nocreate);
		memset(buffer,0,buffermax);
		maxlength=buffermax;
		in.get(buffer,10,lineend[0]);
		if(in.gcount()==0) return;
		sscanf(buffer,"%d",&num);
		if(num!=0) return;
		in.seekg(strlen(lineend),ios::cur);
	}
	memset(buffer,0,buffermax);
	in.read(buffer,buffermax);
	if(strlen(buffer)==0) return;
	if(buffer[0]==headerstart)
	{
		buffer =strchr(buffer,lineend[0])+2;
		checkcolor(buffer);
	}
}

void loadframe(char *name,ULONG num0)
{
	char *buffer=buffernow;
	memset(buffer,0,buffermax);
	if(mode==MODE_MAKING)
	{
		wsprintf(buffer,"%s%04d.txt",name,num0);
		ifstream in(buffer,ios::binary | ios::nocreate);
		memset(buffer,0,buffermax);
		in.read(buffer,buffermax);
		buffer[strlen(buffer)]='\0';
	}
	if(mode==MODE_ALL)
	{
		int num=0;
		char dummy[10];
		wsprintf(buffer,"%s.txt",name);
		ifstream in(buffer,ios::binary | ios::nocreate);
		memset(buffer,0,buffermax);
		//in.get(buffer,10,lineend[0]);
		//in.seekg(strlen(lineend),ios::cur);
		//sscanf(buffer,"%d",&maxlength);
		maxlength=buffermax;
		while(in && num<=num0)
		{
			int n;
			char *p;
			in.get(buffer,10,lineend[0]);
			if(in.gcount()==0)
			{
				playing=FALSE;
				break;
			}
			sscanf(buffer,"%d",&num);
			in.seekg(strlen(lineend),ios::cur);
			memset(buffer,0,buffermax);
			in.read(buffer,maxlength);
			if(in.gcount()==0) 
			{
				playing=FALSE;
				break;
			}
			p=strstr(buffer,endmark);
			if(p!=NULL) *p='\0';
			if(num==num0) break;
			if(num>num0)
			{
				buffer[0]='\0';
				break;
			}
			if(in.eof()) in.clear();
			in.seekg(strlen(buffer)-in.gcount()+strlen(endmark)+strlen(lineend),ios::cur);
			//num++;
		}
	}
	char *p=buffer;
	komanow.reset();
	if(p[0]==headerstart)
	{
		p =nextline(p);
		if(checksame(name,p)) return;
		komanow.colorflag=checkcolor(p);
		if(komanow.colorflag)
		{
			p=nextline(p);
			p=nextline(p);
		}
		komanow.soundflag=checksound(p);
		if(p!=NULL && komanow.soundflag)
		{
			p=nextline(p);
			p=nextline(p);
			soundflag=TRUE;
			if(playing) Sound();
		}
		else
		{
			soundflag=FALSE;
		}
		p =strchr(p,headerend);
		if(p!=NULL) p =nextline(p);
	}
	else
	{
		komanow.noheader();
	}
	komanow.setaadata(p);
	if(!playing) p=buffer;
	strcpy(showbuffer,p);
	wsprintf(buffer,"%ld",getframenum());
	SetDlgItemText(hwndMain,IDC_EDIT1,buffer);


	if(playing==FALSE)
	{
		SetWindowText(hwndEdit,showbuffer);
	}
	drawedit();
}



//---------------------------------------------------
// I[in@t@C@R}t@CɓWJB
// t@Cɂ̓R}ԂB

void filetoframe(char *name)
{
	int num=0;
	char dummy[10];
	char outfile[MAX_PATH];
	char *buffer=buffernow;
	ofstream ou;
	wsprintf(buffer,"%s.txt",name);
	ifstream in(buffer,ios::binary | ios::nocreate);
	memset(buffer,0,buffermax);
	maxlength=buffermax;
	while(in)
	{
		int n;
		char *p;
		in.get(buffer,10,lineend[0]);
		if(in.gcount()==0)
		{
			break;
		}
		sscanf(buffer,"%d",&num);
		in.seekg(strlen(lineend),ios::cur);
		memset(buffer,0,buffermax);
		in.read(buffer,maxlength);
		if(in.gcount()==0) 
		{
			break;
		}
		p=strstr(buffer,endmark);
		if(p!=NULL) *p='\0';
		if(in.eof()) in.clear();
		in.seekg(strlen(buffer)-in.gcount()+strlen(endmark)+strlen(lineend),ios::cur);
		if(strlen(buffer)>0)
		{
			wsprintf(outfile,"%s%04d.txt",name,num);
			ou.open(outfile,ios::binary);
			ou.write(buffer,strlen(buffer));
			ou.close();
		}
	}
}

void copytonext(char *name)
{
	char buffer[MAX_PATH];
	wsprintf(buffer,"%s%04d.txt",name,nownum);
	ifstream in(buffer,ios::binary | ios::nocreate);
	if(!in) return;
	wsprintf(buffer,"%s%04d.txt",name,nownum+1);
	ofstream ou(buffer,ios::binary);
	copyfile(in,ou);
}

void resetcopy()
{
	framecopyflag=FALSE;
}


// --------------------------------
// ܃Rs[Aۂ́@ܔԍL^

void copyframe()
{
	copynum=nownum;
	framecopyflag=TRUE;
}

void pasteframe(char *name)
{
	if(!framecopyflag) return;
	char buffer[MAX_PATH];
	wsprintf(buffer,"%s%04d.txt",name,copynum);
	ifstream in(buffer,ios::binary | ios::nocreate);
	if(!in) return;
	wsprintf(buffer,"%s%04d.txt",name,nownum);
	ofstream ou(buffer,ios::binary);
	copyfile(in,ou);
}