
#include <iostream.h>
#include <windows.h>
#include <fstream.h>
#include <commdlg.h>
#include "font.h"

static LOGFONT logfont ;
static HFONT   hFont ;

BOOL FontChooseFont (HWND hwnd)
{
     CHOOSEFONT cf ;
     
     cf.lStructSize    = sizeof (CHOOSEFONT) ;
     cf.hwndOwner      = hwnd ;
     cf.hDC            = NULL ;
     cf.lpLogFont      = &logfont ;
     cf.iPointSize     = 0 ;
     cf.Flags          = CF_INITTOLOGFONTSTRUCT | CF_SCREENFONTS | CF_EFFECTS ;//
     cf.rgbColors      = 0 ;
     cf.lCustData      = 0 ;
     cf.lpfnHook       = NULL ;
     cf.lpTemplateName = NULL ;
     cf.hInstance      = NULL ;
     cf.lpszStyle      = NULL ;
     cf.nFontType      = 0 ;               // Returned from ChooseFont
     cf.nSizeMin       = 0 ;
     cf.nSizeMax       = 0 ;
     
     return ChooseFont (&cf) ;
}

void FontInitialize (HWND hwndEdit)
{
     GetObject (GetStockObject (SYSTEM_FONT), sizeof (LOGFONT), 
                (PTSTR) &logfont) ;

	 //logfont.lfWidth=max(30,logfont.lfHeight*3);
     hFont = CreateFontIndirect (&logfont) ;
     SendMessage (hwndEdit, WM_SETFONT, (WPARAM) hFont, 0) ;
}

void FontInitialize (HWND hwndEdit,char* file)
{
	FontInitialize (hwndEdit);
	loadfont(file);
	FontSetFont (hwndEdit);
}

void FontSetFont (HWND hwndEdit)
{
     HFONT hFontNew ;
     RECT  rect ;
     
     hFontNew = CreateFontIndirect (&logfont) ;
     SendMessage (hwndEdit, WM_SETFONT, (WPARAM) hFontNew, 0) ;
     DeleteObject (hFont) ;
     hFont = hFontNew ;
     GetClientRect (hwndEdit, &rect) ;
     InvalidateRect (hwndEdit, &rect, TRUE) ;
}


void SetFont(HDC &hdc)
{
    //HFONT hFontNew ;
    //hFontNew = CreateFontIndirect (&logfont) ;
	SelectObject(hdc,hFont);
	//DeleteObject (hFont) ;
	//hFont = hFontNew ;
}

void FontDeinitialize (void)
{
     if(hFont!=NULL)DeleteObject (hFont) ;
}

void loadfont(char *file)
{
	char buff[100];
	ifstream in(file,ios::nocreate);
	if(!in) return;
	in.getline(buff,99);
	if(strlen(buff)>0) strcpy(logfont.lfFaceName,buff);
	logfont.lfWidth=0;
}

void savefont(char *file)
{
	ofstream ou(file);
	ou<<logfont.lfFaceName;
}